$(function() {
    var confirm = true;
    
    populateTable();
    adjustLayout();
    
    $("button").click(function() {
        if (confirm) {
            if (checkCompletion()) {
                saveConfiguration();
                
                $("button").text("Start experiment");
                $("#status").text("Configuration saved.");
                $("#status").css("opacity", "1");
                confirm = false;
            }
        } else {
            window.location = "start.html";
        }
    });
    
    $(window).resize(function() {
        adjustLayout();
    });
});

function populateTable() {
    var testDatasets = utils.getStorageItem("testDatasets").split(",");
    var $table = $("table");
    
    for (var i = 0; i < testDatasets.length; i++) {
        var $tr = $("<tr><td>task " + (i + 1) + "</td></tr>");
        var $td = $("<td></td>");
        var $input = $("<input readonly='readonly'/>");
        $input.attr("name", "d" + i);
        $input.val(testDatasets[i]);
        $td.append($input);
        $tr.append($td);
        $table.append($tr);
    }
}

function adjustLayout() {
    var marginTop = $("h1").outerHeight(true) + $("table").outerHeight(true);
    $("#configure button").css("top", marginTop);
    
    marginTop += $("button").outerHeight(true);
    $("#status").css("top", marginTop);
}

function checkCompletion() {
    var $participantID = $("input[name='participantID']");
    
    if ($participantID.val().length === 0) {
        $("#status").css("opacity", "1");
        $("#status").text("Enter participant ID.");
        $participantID.select();
        
        return false;
    }
    
    var $trainingSpeed = $("#trainingSpeed");
    
    if (!$trainingSpeed.val().match(/ANIMATION_SPEED/)) {
        $("#status").css("opacity", "1");
        $("#status").text("Choose initial training speed.");
        
        return false;
    }
    var $testingSpeed = $("#testingSpeed");
    
    if (!$testingSpeed.val().match(/ANIMATION_SPEED/)) {
        $("#status").css("opacity", "1");
        $("#status").text("Choose initial testing speed.");
        
        return false;
    }
    return true;
}

function saveConfiguration() {
    var participantID = $("input[name='participantID']").val();
    var trainingSpeed = $("#trainingSpeed").val();
    var testingSpeed = $("#testingSpeed").val();
    
    utils.setStorageItem("participantID", participantID);
    utils.setStorageItem("animationSpeed", trainingSpeed);
    utils.setStorageItem("testingSpeed", testingSpeed);
    utils.setStorageItem("taskNumber", 0);
    
    logger.init();
    logger.log("-- PARTICIPANT " + participantID + " configured --");
}
