var logger = function(logger, undefined) {
// visible ////////////////////////////////////////////////////////////////////
    var visible = {};
    
    visible.init = function() {
        // preserve log if it already exists
        if (utils.getStorageItem("log") === null) {
            utils.setStorageItem("log", "");
        }
        
        if (utils.getStorageItem("entryNumber") === null) {
            utils.setStorageItem("entryNumber", 0);
        }
    }
    
    visible.log = function(entry) {
        utils.setStorageItem("log", utils.getStorageItem("log") +
                entryID() + "\t" + visible.dateString(new Date()) + "\t" +
                entry + "\n");
    };
    
    visible.dump = function() {
        console.log("-- START LOG DUMP -----------------------------");
        console.log(utils.getStorageItem("log"));
        console.log("-- END LOG DUMP -------------------------------");
    };
    
    visible.dateString = function(date) {
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var day = date.getDate();
        var ms = date.getUTCMilliseconds();
        
        month = month < 10 ? "0" + month : month;
        day = day < 10 ? "0" + day : day;
        ms = ms < 10 ? "00" + ms : (ms < 100 ? "0" + ms : ms);
        
        return year + "-" + month + "-" + day + " " +
                date.toLocaleTimeString() + ":" + ms;
    };
    
    visible.itemString = function(id) {
        var item = model.items[id];
        var list = item.listID === model.list1.id ? model.list1 : model.list2;
        
        return "item " + item.name + " (" + id + ", " + list.name + ")";
    }
    
// hidden /////////////////////////////////////////////////////////////////////
    function entryID() {
        var entryNumber = utils.getStorageItem("entryNumber");
        var entryID = utils.getStorageItem("participantID") + "-" + entryNumber;
        entryNumber++;
        utils.setStorageItem("entryNumber", entryNumber);
        
        return entryID;
    }

    // expose interface ///////////////////////////////////////////////////////
    return visible;
}(window.logger = window.logger || {});