var model = function(model, jQuery) {
////// visible ////////////////////////////////////////////////////////////////
    var visible = {};
    
    
    // pseudo constants ///////////////////////////////////////////////////////
    visible.ATTR_NAME = "__ATTR_NAME__";
    visible.ATTR_ROUTE = "__ATTR_ROUTE__";
    visible.ATTR_FREQUENCY = "__ATTR_FREQUENCY__";
    visible.ATTR_DOSAGE = "__ATTR_DOSAGE__";
    visible.ATTR_DRUG_CLASS = "__ATTR_DRUG_CLASS__";
    visible.ATTR_SUBITEM = "__ATTR_SUBITEM__";
    visible.ATTR_INSTRUCTIONS = "__ATTR_INSTRUCTIONS__";
    
    visible.ATTR_TYPE_NUMERIC = "__ATTR_TYPE_NUMERIC__";
    visible.ATTR_TYPE_GENERAL = "__ATTR_TYPE_GENERAL__";
    visible.ATTR_TYPE_CATEGORICAL = "__ATTR_TYPE_CATEGORICAL__";
    
    visible.DATASET_TRAINING = "__DATASET_TRAINING__";
    visible.DATASET_01 = "__DATASET_01__";
    visible.DATASET_02 = "__DATASET_02__";
    visible.DATASET_03 = "__DATASET_03__";
    visible.DATASET_04 = "__DATASET_04__";
    visible.DATASET_05 = "__DATASET_05__";
    visible.DATASET_06 = "__DATASET_06__";
    visible.DATASET_07 = "__DATASET_07__";
    visible.DATASET_08 = "__DATASET_08__";
    
    visible.DATASET_DEFAULT = visible.DATASET_TRAINING;
    
    visible.AFTER_ACTION_GRAYOUT = "__AFTER_ACTION_GRAYOUT__";
    visible.AFTER_ACTION_REMOVE = "__AFTER_ACTION_REMOVE__";
    
    visible.FILTER_DELAY_SCALE = 4;
    
    
    // data ///////////////////////////////////////////////////////////////////
    visible.dataset = "";
    visible.items = {};
    
    visible.shadows = {};
    visible.itemsToShadows = {};
    visible.shadowsToItems = {};
    visible.hidden = {};
    
    visible.list1 = {
                id: "list0",
                name: "Intake",
                source: []
            };
    visible.list2 = {
                id: "list1",
                name: "Hospital",
                source: []
            };
    
    visible.viewData = function(sort, filter) {
        var viewData = visible.list1.source.concat(visible.list2.source);
        
        if (visible.multigroup && visible.groupBy) {
            for (var shadowID in visible.shadows) {
                var shadow = visible.shadows[shadowID];
                
                if (visible.groupBy in shadow.attributes &&
                        shadow.attributes[visible.groupBy].length > 1) {
                    viewData.push(shadowID);
                    
                    if (shadowID in visible.hidden) {
                        delete visible.hidden[shadowID];
                        visible.toggleItem($("#" + shadowID),
                                controller.toggleOnDelay, true);
                    }
                } else {
                    visible.toggleItem($("#" + shadowID),
                            controller.toggleOffDelay, false);
                    visible.hidden[shadowID] = true;
                }
            }
        } else {
            // no multigroup + groupBy = no shadows
            for (var shadowID in visible.shadows) {
                visible.toggleItem($("#" + shadowID),
                        controller.toggleOffDelay, false);
                visible.hidden[shadowID] = true;
            }
        }

        if (filter) {
            viewData = viewData.filter(unifiedFilter);
        }
        
        if (sort || filter) {
            viewData = viewData.sort(groupThenSort);
        }
        return viewData;
    }
    
    visible.attributes = {};

    visible.groupBy = "";
    visible.sortBy = "";
    visible.__defineGetter__("filterOn", function() {
        return filterOn;
    });
    visible.__defineSetter__("filterOn", function(value) {
        filterOn = value.toLowerCase();
    });
    visible.multigroup = false;
    
    visible.afterAction = visible.AFTER_ACTION_GRAYOUT;
    
    visible.unique1 = [];
    visible.unique2 = [];
    visible.identical = {};
    visible.similar = {};
    
    
    // methods ////////////////////////////////////////////////////////////////
    visible.init = function(dataset) {
        loadData(dataset);
    };
    
    visible.getIdentical = function(id) {
        var identical = [];
        
        if (id in visible.identical) {
            identical = visible.identical[id].slice();
        }
        identical.splice(identical.indexOf(parseFloat(id)), 1);
        
        return identical.filter(unifiedFilter);
    };
    
    visible.getSimilar = function(id) {
        var similar = [];
        
        if (id in visible.similar) {
            similar = visible.similar[id].items.slice();
        }
        similar.splice(similar.indexOf(parseFloat(id)), 1);

        return similar.filter(unifiedFilter);
    };
    
    visible.getRelated = function(id) {
        var identical = visible.getIdentical(id);
        var similar = visible.getSimilar(id);
        var hash = {};
        var length = Math.min(identical.length, similar.length); 
        
        // remove duplicates
        for (var i = 0; i < length; i++) {
            hash[identical[i]] = true;
            hash[similar[i]] = true;
        }
        
        if (length < identical.length) {
            for ( ; i < identical.length; i++) {
                hash[identical[i]] = true;
            }
        } else if (length < similar.length) {
            for ( ; i < similar.length; i++) {
                hash[similar[i]] = true;
            }
        }
        
        // convert results into array format
        var related = [];
        
        for (var hashedID in hash) {
            related.push(hashedID);
        }
        return related;
    };
    
    visible.getShadows = function(id) {
        if (id in visible.itemsToShadows) {
            return visible.itemsToShadows[id];
        }
        return [];
    };
    
    visible.getShadowed = function(id) {
        if (id in visible.shadowsToItems) {
            return visible.shadowsToItems[id];
        }
        return undefined;
    };
    
    visible.getVisibleShadows = function(id) {
        var visibleShadows = [];
        
        if (id in visible.itemsToShadows) {
            var shadows = visible.getShadows(id);
            
            for (var i = 0; i < shadows.length; i++) {
                var shadowID = shadows[i];
                var shadow = visible.items[shadowID];
                
                if (visible.hidden[shadowID] === undefined) {
                    visibleShadows.push(shadowID);
                }
            }
        }
        return visibleShadows;
    };
    
    
    visible.toggleItem = function($item, delay, show) {
        if (show) {
            if (visible.hidden[$item.attr("id")] === undefined) {
                $item.show();
                
                setTimeout(function() {
                    $item.css("opacity", "1");
                }, delay);
            }
        } else {
            setTimeout(function() {
                $item.css("opacity", "0");
                
                setTimeout(function() {
                    $item.hide();
                    $item.removeClass("undecided-hover item-hover");
                }, delay);
            }, delay);
        }
    };
    
    
////// hidden /////////////////////////////////////////////////////////////////
    var filterOn = "";
    
    // initialization
    function loadData(dataset) {
        visible.dataset = dataset;
        populateLists(dataset);
        detectAttributes();
        detectRelationships(dataset);
        
        // create "shadows", copies, to show n-group affiliation
        populateShadows();
    }
    
    function populateLists(dataset) {
        var i = 0, attributes = {}, item = {};
        
        if (dataset === visible.DATASET_TRAINING) {
            // populate list 1
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID PRN"];
            attributes[visible.ATTR_DOSAGE] = ["60 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take twice daily as needed"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Fexofenadine",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q6h"];
            attributes[visible.ATTR_DOSAGE] = ["325 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["analgesic", "antipyretic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Acetaminophen",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IN"];
            attributes[visible.ATTR_FREQUENCY] = ["BID PRN"];
            attributes[visible.ATTR_DOSAGE] = ["137 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["once in the morning, once at night as needed"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Astepro",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IN"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["50 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["topical steroid"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["once in the morning, once at night"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Nasonex",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["2000 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take two tablets daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Glucosamine supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Zyrtec",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            // populate list 2
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["20 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["corticosteroid"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Prednisone",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["PRN"];
            attributes[visible.ATTR_DOSAGE] = ["25 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            attributes[visible.ATTR_INSTRUCTIONS] = ["take only as needed"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Dipenhydramine",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID PRN"];
            attributes[visible.ATTR_DOSAGE] = ["60 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take twice daily as needed"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Fexofenadine",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q6h"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["analgesic", "antipyretic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Tylenol",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["PRN"];
            attributes[visible.ATTR_DOSAGE] = ["1000 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["vitamin"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Vitamin C",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["1000 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["vitamin"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take once daily with food"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Vitamin D",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take twice daily with food"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Calcium supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
        } else if (dataset === visible.DATASET_01) {
            // populate list 1
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IV"];
            attributes[visible.ATTR_FREQUENCY] = ["q4h"];
            attributes[visible.ATTR_DOSAGE] = ["50 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["glycylcycline antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Tygacil",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["1200 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take two softgels daily,with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Fish oil supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q4h"];
            attributes[visible.ATTR_DOSAGE] = ["200 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["NSAID"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["if pain or fever does not respond to 1 tablet, " +
                    "2 tablets may be used"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Advil",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["500 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["vitamin"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Vitamin B-12",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["60 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["lipase inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Alli",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            // populate list 2
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["250 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["vitamin"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Vitamin B-12",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["12.5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Carvedilol",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q4h"];
            attributes[visible.ATTR_DOSAGE] = ["200 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["NSAID"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["if pain or fever does not respond to 1 tablet, " +
                    "2 tablets may be used"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Advil",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["1000 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take three softgels daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Fish oil supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["120 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["lipase inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Orlistat",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
        } else if (dataset === visible.DATASET_02) {
            // populate list 1
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["25 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Coreg",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q8h"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["penicillin-like antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Amoxicillin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["400 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Folic acid supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["20 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Quinapril",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["nucleotide analog"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Hepsera",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            // populate list 2
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q8h"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["penicillin-like antibiotic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Amoxicillin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["30 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Zinc supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Quinapril",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["25 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Coreg",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID PRN"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take twice daily as needed"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Claritin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["400 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Folic acid supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["200 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["methylxanthine"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Theophylline",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["nucleotide analog"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Hepsera",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
        } else if (dataset === visible.DATASET_03) {
            // populate list 1
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["4 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antimuscarinic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Fesoterodine",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["QID"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["tetracycline antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Tetracycline",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["anticoagulant"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Marfarin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["unknown"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Pyrazinamide",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["4 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["alpha agonist"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Wytensin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["macrolide antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Zithromax",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["20 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one softgel daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Lutein supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q4h"];
            attributes[visible.ATTR_DOSAGE] = ["200 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["NSAID"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["if pain or fever does not respond to 1 tablet, " +
                    "2 tablets may be used"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Ibuprofen",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            // populate list 2
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["macrolide antibiotic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Azithromycin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["25 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["diuretic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Chlorthalidone",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["QID"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["tetracycline antibiotic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Tetracycline",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["20 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one softgel daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Lutein supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
        } else if (dataset === visible.DATASET_04) {
            // populate list 1
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["40 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Benazepril",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["125 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["glycopeptide antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Vancocin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Lotensin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
                        
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["0.5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["5-HT3 antagonist"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Alosetron",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;

            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IV"];
            attributes[visible.ATTR_FREQUENCY] = ["q3w"];
            attributes[visible.ATTR_DOSAGE] = ["220 mg/m2"];
            attributes[visible.ATTR_DRUG_CLASS] = ["purine analog"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "DTIC",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antifungal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Terbinafine",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Lotensin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["4 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["statin"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Livalo",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q8h"];
            attributes[visible.ATTR_DOSAGE] = ["648 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antimalarial"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Qualaquin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            // populate list 2
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IV"];
            attributes[visible.ATTR_FREQUENCY] = ["q3w"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg/m2"];
            attributes[visible.ATTR_DRUG_CLASS] = ["purine analog"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "DTIC",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antifungal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Terbinafine",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q8h"];
            attributes[visible.ATTR_DOSAGE] = ["648 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antimalarial"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Qualaquin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["125 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["glycopeptide antibiotic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Vancocin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["1 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["5-HT3 antagonist"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Alosetron",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["2 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["statin"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Livalo",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
        } else if (dataset === visible.DATASET_05) {
            // populate list 1
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["1605 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take two tablets daily,with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Acai supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["7.5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Univasc",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q8h"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["penicillin-like antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Amoxicot",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IN"];
            attributes[visible.ATTR_FREQUENCY] = ["BID PRN"];
            attributes[visible.ATTR_DOSAGE] = ["137 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["once in the morning, once at night as needed"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Azelastine",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["--"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Cod liver oil supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["50 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["anticonvulsant"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Pregabalin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["80 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Corgard",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["20 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["corticosteroid"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Deltasone",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["1000 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one softgel two to three times daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Flaxseed oil supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IN"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["50 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["topical steroid"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["once in the morning, once at night"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Mometasone",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["300 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Omnicef",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["400 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Sectral",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q6h"];
            attributes[visible.ATTR_DOSAGE] = ["30 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["decongestant"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Sudafed",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["400 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Toprol",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["60 / 120 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine", "decongestant"];
            attributes[visible.ATTR_SUBITEM] = [
                        {
                            name: "Fexofenadine",
                            attributes: { "__ATTR_DOSAGE__" : ["60 mg"] }
                        },
                        {
                            name: "Pseudoephedrine",
                            attributes: { "__ATTR_DOSAGE__" : ["120 mg"] }
                        }
                    ];
            
            
            // populate list 2
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["--"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Cod liver oil supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["1605 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take two tablets daily,with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Acai supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IN"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["50 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["topical steroid"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["once in the morning, once at night"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Mometasone",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["1000 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one softgel two to three times daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Flaxseed oil supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["100 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Toprol",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["40 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Corgard",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["15 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Univasc",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q8h"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["penicillin-like antibiotic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Amoxicot",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["240 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["decongestant"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Sudafed",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["corticosteroid"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Deltasone",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["400 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Sectral",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IN"];
            attributes[visible.ATTR_FREQUENCY] = ["BID PRN"];
            attributes[visible.ATTR_DOSAGE] = ["137 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["once in the morning, once at night as needed"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Azelastine",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["300 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antibiotic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Omnicef",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["50 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["anticonvulsant"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Pregabalin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
        } else if (dataset === visible.DATASET_06) {
            // populate list 1
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Accupril",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["200 IU"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one softgel one to two times daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Vitamin E",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["450 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take two capsules one time daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "St. John's wort supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["2 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["statin"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Pitavastatin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["anticoagulant"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Coumadin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["--"];
            attributes[visible.ATTR_DRUG_CLASS] = ["vitamin"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Multi-Complete multivitamin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q6h"];
            attributes[visible.ATTR_DOSAGE] = ["325 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["analgesic", "antipyretic"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet every six hours"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Paracetamol",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["60 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["lipase inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Xenical",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["400 IU"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one softgel one to two times daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Vitamin E",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["30 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take two capsules three times daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Ginkgo biloba supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;

            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["20 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Accupril",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["QID"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["tetracycline antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Panmycin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q8h"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["penicillin-like antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Moxilin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IV"];
            attributes[visible.ATTR_FREQUENCY] = ["q3w"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg/m2"];
            attributes[visible.ATTR_DRUG_CLASS] = ["purine analog"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Dacarbazine",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            // populate list 2
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["4 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["statin"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Pitavastatin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Magnesium supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["1000 IU"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one softgel daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Vitamin E",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;

            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IV"];
            attributes[visible.ATTR_FREQUENCY] = ["q3w"];
            attributes[visible.ATTR_DOSAGE] = ["220 mg/m2"];
            attributes[visible.ATTR_DRUG_CLASS] = ["purine analog"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Dacarbazine",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IV"];
            attributes[visible.ATTR_FREQUENCY] = ["q4h"];
            attributes[visible.ATTR_DOSAGE] = ["50 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["glycylcycline antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Tigecycline",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["0.5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["5-HT3 antagonist"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Lotronex",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["PRN"];
            attributes[visible.ATTR_DOSAGE] = ["25 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Tusstat",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;

            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["550 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Potassium supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["biguanide"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take once daily with evening meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Riomet",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["30 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take two capsules three times daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Ginkgo biloba supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["200 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["methylxanthine"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Uni-Dur",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["QID"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["tetracycline antibiotic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Panmycin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
        } else if (dataset === visible.DATASET_07) {
            // populate list 1
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["750 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["anti-inflammatory drug"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Balsalazide",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID PRN"];
            attributes[visible.ATTR_DOSAGE] = ["60 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Wal-Fex",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["400 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Acebutolol",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "L-Lysine supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["2 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["5-HT3 antagonist"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one hour before radiation"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Kytril",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["biguanide"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take once daily with evening meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Glumetza",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["salicylate"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Aspirin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Lisinopril",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["1250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["tablet should be swallowed without chewing"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Garlic supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Renitec",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["200 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take two tablets daily, " + 
                    "at least 30 minutes before a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "SAM-e supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["250 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one capsule one to two times daily,with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Ginseng supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["65 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Iron supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["40 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Nadolol",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["benzodiazepine"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Oxazepam",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["40 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["proton-pump inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Pantoprazole",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            // populate list 2
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["proton-pump inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Pantoprazole",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["65 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Iron supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["8000 IU"];
            attributes[visible.ATTR_DRUG_CLASS] = ["vitamin"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one softgel daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Vitamin A",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["10 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Lisinopril",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
                        
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["40 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["beta blocker"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Nadolol",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["QHS"];
            attributes[visible.ATTR_DOSAGE] = ["400 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one or two capsules one hour before bedtime"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Valerian supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["500 million cells"];
            attributes[visible.ATTR_DRUG_CLASS] = ["probiotic"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet two times daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Acidophilus probiotic",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["20 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Enalapril",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["1000 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "L-Lysine supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["180 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Wal-Fex",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["15 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["benzodiazepine"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Serax",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
        } else if (dataset === visible.DATASET_08) {
            // populate list 1
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["200 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Selenium supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IN"];
            attributes[visible.ATTR_FREQUENCY] = ["PRN"];
            attributes[visible.ATTR_DOSAGE] = ["90 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["corticosteroid"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Budesonide",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["various"];
            attributes[visible.ATTR_DRUG_CLASS] = ["probiotic"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily with a cold or room " +
                    "temperature drink"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Triple probiotic",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["300 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antiretroviral"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Lamivudine",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["anticoagulant"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Warfarin",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["180 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Allegra",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Melatonin supplement",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q6h"];
            attributes[visible.ATTR_DOSAGE] = ["325 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["analgesic", "antipyretic"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet every six hours"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Acephen",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["300 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antibiotic"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Cefdinir",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list1.id,
                        id: i,
                        name: "Vasotec",
                        attributes: attributes
                    };
            visible.list1.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            // populate list 2
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["125 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["glycopeptide antibiotic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Vancomycin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["60 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Allegra",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["40 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["proton-pump inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Protonix",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Vasotec",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["2 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["anticoagulant"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Warfarin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IN"];
            attributes[visible.ATTR_FREQUENCY] = ["PRN"];
            attributes[visible.ATTR_DOSAGE] = ["180 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["corticosteroid"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Budesonide",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["IN"];
            attributes[visible.ATTR_FREQUENCY] = ["BID PRN"];
            attributes[visible.ATTR_DOSAGE] = ["137 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antihistamine"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["once in the morning, once at night as needed"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Astelin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["q6h"];
            attributes[visible.ATTR_DOSAGE] = ["120 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["analgesic", "antipyretic"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet every six hours"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Acephen",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["300 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antibiotic"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Cefdinir",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["5 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["ACE inhibitor"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Zestril",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["200 mcg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily, with a meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Selenium supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["500 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["biguanide"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take once daily with evening meal"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Metformin",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["300 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["supplement"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take with meals"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Krill oil supplement",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["various"];
            attributes[visible.ATTR_DRUG_CLASS] = ["probiotic"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one tablet daily with a cold or room " +
                    "temperature drink"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Triple probiotic",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["BID"];
            attributes[visible.ATTR_DOSAGE] = ["150 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["antiretroviral"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Lamivudine",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["daily"];
            attributes[visible.ATTR_DOSAGE] = ["2 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["5-HT3 antagonist"];
            attributes[visible.ATTR_INSTRUCTIONS] =
                    ["take one hour before radiation"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Granisetron",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
            
            
            attributes = {};
            attributes[visible.ATTR_ROUTE] = ["PO"];
            attributes[visible.ATTR_FREQUENCY] = ["TID"];
            attributes[visible.ATTR_DOSAGE] = ["750 mg"];
            attributes[visible.ATTR_DRUG_CLASS] = ["anti-inflammatory drug"];
            
            item = {
                        listID: visible.list2.id,
                        id: i,
                        name: "Colazal",
                        attributes: attributes
                    };
            visible.list2.source.push(item.id);
            visible.items[item.id] = item;
            i++;
        }
    }
    
    function populateShadows() {
        for (var id in visible.items) {
            var item = visible.items[id];
            
            // originals will always be associated with the primary group
            item.groupByOffset = 0;
            
            // originals are not shadows, and currently have no shadows
            item.isShadow = false;
            item.isShadowed = false;
            
            // search for potential shadows
            for (var attributeName in visible.attributes) {
                var attribute = visible.attributes[attributeName];
                
                if (attribute.type === visible.ATTR_TYPE_CATEGORICAL) {
                    if (attributeName in item.attributes) {
                        var values = item.attributes[attributeName];
                        
                        if (values.length > 1) {
                            /*
                             * Prepare shadows; these "shadows" will only appear
                             * when the user groups by this particular
                             * attribute.
                             * 
                             * For group affiliation [ A, B, C ]:
                             *   - the original will be grouped with A,
                             *   - shadow 0 will be grouped with B, and
                             *   - shadow 1 will be grouped with C.
                             * 
                             * Acting on the original will act on all shadows;
                             * acting on a shadow will similarly act on the
                             * original (and all other shadows).
                             */
                            for (var i = 1; i < values.length; i++) {
                                // convention: originalID_shadowID
                                var shadowID = id + "_" + (i - 1);
                                
                                // create the shadow from the original
                                visible.shadows[shadowID] = {};
                                $.extend(true, visible.shadows[shadowID],
                                        visible.items[id]);
                                        
                                var shadow = visible.shadows[shadowID];
                                
                                shadow.id = shadowID;
                                shadow.isShadow = true;
                                shadow.isShadowed = false;
                                shadow.groupByOffset = i;
                                
                                // original now has a shadow
                                visible.items[id].isShadowed = true;
                                
                                // for convenience, hash in items as well
                                visible.items[shadowID] = {};
                                $.extend(visible.items[shadowID],
                                        visible.shadows[shadowID]);
                                        
                                // hash from original to shadow
                                if (id in visible.itemsToShadows) {
                                    visible.itemsToShadows[id].push(shadowID);
                                } else {
                                    visible.itemsToShadows[id] = [shadowID];
                                }
                                
                                // hash from shadow to original
                                visible.shadowsToItems[shadowID] = id;
                            }
                        }
                    }
                }
            }
        }
    }
    
    function detectAttributes() {
        visible.attributes[visible.ATTR_NAME] = {
                    type: visible.ATTR_TYPE_GENERAL,
                    display: true
                };
        visible.attributes[visible.ATTR_ROUTE] = {
                    type: visible.ATTR_TYPE_CATEGORICAL,
                    display: true
                };
        visible.attributes[visible.ATTR_FREQUENCY] = {
                    type: visible.ATTR_TYPE_GENERAL,
                    display: true
                };
        visible.attributes[visible.ATTR_DOSAGE] = {
                    type: visible.ATTR_TYPE_NUMERIC,
                    display: true
                };
        visible.attributes[visible.ATTR_DRUG_CLASS] = {
                    type: visible.ATTR_TYPE_CATEGORICAL,
                    display: false
                };
        visible.attributes[visible.ATTR_SUBITEM] = {
                    type: visible.ATTR_TYPE_GENERAL,
                    display: false
                };
        visible.attributes[visible.ATTR_INSTRUCTIONS] = {
                    type: visible.ATTR_TYPE_GENERAL,
                    display: false
                };
    }
    
    function detectRelationships(dataset) {
        var i, identical, similar;
        
        if (dataset === visible.DATASET_TRAINING) {
            visible.unique1 = [2, 3, 4, 5];
            visible.unique2 = [6, 7, 10, 11, 12];
            
            identical = [
                    [0, 8]
                    ];
            
            similar = [
                    {
                        items: [1, 9],
                        differences: [visible.ATTR_NAME, visible.ATTR_DOSAGE]
                    }
                    ];
        } else if (dataset === visible.DATASET_01) {
            visible.unique1 = [0];
            visible.unique2 = [6];
            
            identical = [
                    [2, 7]
                    ];
            
            similar = [
                    {
                        items: [1, 8],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [3, 5],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [4, 9],
                        differences: [visible.ATTR_NAME, visible.ATTR_DOSAGE]
                    }
                    ];
        } else if (dataset === visible.DATASET_02) {
            visible.unique1 = [];
            visible.unique2 = [6, 9, 11];
            
            identical = [
                    [0, 8],
                    [1, 5],
                    [2, 10],
                    [4, 12]
                    ];
            
            similar = [
                    {
                        items: [3, 7],
                        differences: [visible.ATTR_DOSAGE]
                    }
                    ];
        } else if (dataset === visible.DATASET_03) {
            visible.unique1 = [0, 2, 3, 4, 7];
            visible.unique2 = [9];
            
            identical = [
                    [6, 11]
                    ];
            
            similar = [
                    {
                        items: [1, 10],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [5, 8],
                        differences: [visible.ATTR_NAME, visible.ATTR_DOSAGE]
                    }                    
                    ];
        } else if (dataset === visible.DATASET_04) {
            visible.unique1 = [0];
            visible.unique2 = [];
            
            identical = [
                    [1, 12],
                    [2, 6],
                    [5, 10],
                    [8, 11]
                    ];
            
            similar = [
                    {
                        items: [3, 13],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [4, 9],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [7, 14],
                        differences: [visible.ATTR_DOSAGE]
                    }
                    ];
        } else if (dataset === visible.DATASET_05) {
            visible.unique1 = [];
            visible.unique2 = [];
            
            identical = [
                    [0, 15],
                    [2, 21],
                    [3, 25],
                    [4, 14],
                    [5, 27],
                    [8, 17],
                    [9, 16],
                    [10, 26],
                    [11, 24]
                    ];
            
            similar = [
                    {
                        items: [6, 19],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [7, 23],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [12, 22],
                        differences: [visible.ATTR_FREQUENCY,
                                visible.ATTR_DOSAGE]
                    },
                    {
                        items: [13, 18],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [1, 20],
                        differences: [visible.ATTR_DOSAGE]
                    }
                    ];
        } else if (dataset === visible.DATASET_06) {
            visible.unique1 = [2, 4, 5, 6, 7, 12, 18];
            visible.unique2 = [15, 19, 20, 21, 22, 24];
            
            identical = [
                    [9, 23]
                    ];
            
            similar = [
                    {
                        items: [0, 10],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [1, 8, 16],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [3, 14],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [11, 25],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [13, 17],
                        differences: [visible.ATTR_DOSAGE]
                    }
                    ];
        } else if (dataset === visible.DATASET_07) {
            visible.unique1 = [0, 2, 4, 5, 6, 8, 10, 11];
            visible.unique2 = [18, 21, 22];
            
            identical = [
                    [12, 17],
                    [13, 20]
                    ];
            
            similar = [
                    {
                        items: [1, 25],
                        differences: [visible.ATTR_FREQUENCY,
                                visible.ATTR_DOSAGE]
                    },
                    {
                        items: [3, 24],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [7, 19],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [9, 23],
                        differences: [visible.ATTR_NAME, visible.ATTR_DOSAGE]
                    },
                    {
                        items: [14, 26],
                        differences: [visible.ATTR_NAME, visible.ATTR_DOSAGE]
                    },
                    {
                        items: [15, 16],
                        differences: [visible.ATTR_DOSAGE]
                    }
                    ];
        } else if (dataset === visible.DATASET_08) {
            visible.unique1 = [6];
            visible.unique2 = [10, 12, 16, 19, 21, 22, 25, 26];
            
            identical = [
                    [0, 20],
                    [2, 23],
                    [8, 18],
                    [9, 13]
                    ];
            
            similar = [
                    {
                        items: [1, 15],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [4, 14],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [5, 11],
                        differences: [visible.ATTR_FREQUENCY,
                                visible.ATTR_DOSAGE]
                    },
                    {
                        items: [7, 17],
                        differences: [visible.ATTR_DOSAGE]
                    },
                    {
                        items: [3, 24],
                        differences: [visible.ATTR_FREQUENCY,
                                visible.ATTR_DOSAGE]
                    }
                    ];
        }
        
        if (identical || similar) {
            for (i = 0; i < identical.length; i++) {
                var set = identical[i];
                
                for (var j = 0; j < set.length; j++) {
                    visible.identical[set[j]] = set;
                }
            }
            
            for (i = 0; i < similar.length; i++) {
                set = similar[i];
                
                for (j = 0; j < set.items.length; j++) {
                    visible.similar[set.items[j]] = set;
                }
            }
        }
    }
    
    
    // sort
    function groupThenSort(a, b) {
        var groupOrder = visible.groupBy ?
                attributeSort(a, b, visible.groupBy) : 0;
        
        if (groupOrder === 0) {
            var sortOrder = visible.sortBy ?
                    attributeSort(a, b, visible.sortBy) :
                    visible.items[a].id - visible.items[b].id;
                    
            if (visible.sortBy && sortOrder === 0) {
                return visible.items[a].id - visible.items[b].id;
            }
            return sortOrder;
        }
        return groupOrder;
    }
    
    function attributeSort(a, b, attribute) {
        var itemA = visible.items[a];
        var itemB = visible.items[b];
        var attributeA, attributeB;
        
        if (attribute === visible.ATTR_NAME) {
            attributeA = itemA.name;
            attributeB = itemB.name;
        } else {
            attributeA = itemA.attributes[attribute][
                    (visible.multigroup ? itemA.groupByOffset : 0)];
            attributeB = itemB.attributes[attribute][
                    (visible.multigroup ? itemB.groupByOffset : 0)];
        }
        
        if (visible.attributes[attribute].type === visible.ATTR_TYPE_NUMERIC) {
            attributeA = parseFloat(attributeA);
            attributeB = parseFloat(attributeB);
        }
        
        if (attributeA < attributeB) {
            return -1;
        } else if (attributeA > attributeB) {
            return 1;
        } else {
            return 0;
        }
    }
    
    
    // filter
    function actionFilter(element, index, array) {
        var $item = $("#" + element);
        
        if (visible.afterAction === visible.AFTER_ACTION_REMOVE &&
                !$item.hasClass("undecided")) {
            return false;
        }
        return true;
    }
    
    function nameFilter(element, index, array) {
        var $item = $("#" + element);
        
        if (visible.filterOn.length > 0 &&
                visible.items[element].name.toLowerCase()
                .indexOf(visible.filterOn) === -1) {
            return false;
        }
        return true;
    }
    
    function unifiedFilter(element, index, array) {
        var keep = actionFilter(element, index, array);
        
        if (keep) {
            keep = nameFilter(element, index, array);
        }
        visible.toggleItem($("#" + element), keep ?
                controller.toggleOnDelay * visible.FILTER_DELAY_SCALE :
                controller.toggleOffDelay / visible.FILTER_DELAY_SCALE,
                keep);
        return keep;
    }
    
    
    // expose interface ///////////////////////////////////////////////////////
    return visible;
}(window.model = window.model || {}, $, undefined);
